<?php

interface RESAMPLERInterface {
 function Resample($data, $flags = 0);
};

abstract class RESAMPLER implements RESAMPLERInterface {
  var $options;
  
  function __construct(REQUEST $req  = NULL, array $options = NULL , $sampling = false) {
    $this->options = $options?$options:array();
  }

 function GetOption($opt, $default = false) {
    if (isset($this->options[$opt])) return $this->options[$opt];
    return $default;
 }

  function GetNumberOfChannels($data) {
	// We can compute later
    return $data['info']['n_channels'];
  }

  static function IsApplicable($sampling = false) {
    if ($sampling) 
	return false;

    return true;
  }

  static function GetResampler(REQUEST $req  = NULL, $resampler, $sampling = false) {
    global $ADEI_RESAMPLERS;

    $cfg = $ADEI_RESAMPLERS[$resampler];
    if (!$cfg) throw new ADEIException(translate("Unsupported resampler (%s) is configured", $resampler));

    ADEI::RequireClass("resamplers/" . strtolower($cfg['handler']), true);
    $r = new $cfg['handler']($req, $cfg['opts'], $sampling);
    return $r;
 }

 static function GetSelectList($sampling = false) {
    global $ADEI;
    global $ADEI_RESAMPLERS;

    $res = array();
    foreach ($ADEI_RESAMPLERS as $name => $cfg) {
	ADEI::RequireClass("resamplers/" . strtolower($cfg['handler']), true);

        if ($cfg['handler']::IsApplicable($sampling)) {
	    array_push($res, array(
		'value' => $name,
		'label' => $cfg['title'],
	    ));
	}
    }
    return $res;
  }

/*
  static function GetMethods() {
    global $ADEI_RESAMPLERS;

    $root = ADEI::GetRootDir();
    $setup = ADEI::GetSetupDir();

    $names = array_merge(glob("$setup/classes/resamplers/*.php"), glob("$root/classes/resamplers/*.php"));
    foreach ($names as &$name) {
	$name = basename($name, ".php");
    }
    $names = array_uniq($names);

    foreach $names as $name {
	ADEI::RequireClass("resamplers/$name");
    }
*/
}

?>