<?php
    function env($var, $default = false) {
	$env = getenv($var);
	if ($env === false) return $default;
	return $env;
    }
    
    switch($_GET['mysql']) {
      case "master":
        $mysql = "MYSQL_MASTER_SERVER";
        break;
      case "slave":
        $mysql = "MYSQL_SLAVE_SERVER";
        break;
      default:
        $mysql = "MYSQL_SERVER";
    }        

    $ADEI_SETUP = env("ADEI_SETUP", "all");

    $ADEI_RELEASE = filter_var(env("ADEI_RELEASE", $ADEI_RELEASE), FILTER_VALIDATE_BOOLEAN);
    $LOGGER_LOG_REQUESTS = filter_var(env("ADEI_WRITE_LOGS", $LOGGER_LOG_REQUESTS), FILTER_VALIDATE_BOOLEAN);
    $LOGGER_LOG_OUTPUT = filter_var(env("ADEI_WRITE_LOGS", $LOGGER_LOG_OUTPUT), FILTER_VALIDATE_BOOLEAN);
    $LOGGER_STORE_OBJECTS = filter_var(env("ADEI_DEBUG", $LOGGER_STORE_OBJECTS), FILTER_VALIDATE_BOOLEAN);

    $ADEI_DB = array (
	"host" => env($mysql, env("MYSQL_SERVER", "localhost")),
	"port" => env("MYSQL_PORT", 0),
	"database" => env("MYSQL_DATABASE", "adei"),
	"user" => env("MYSQL_USER", "adei"),
	"password" => env("MYSQL_PASSWORD", "adei")
    );

    $ADEI_CACHE_ENGINE = env("ADEI_CACHE_ENGINE", $ADEI_CACHE_ENGINE);
    $ADEI_CACHE_COMPRESSION = env("ADEI_CACHE_COMPRESSION", $ADEI_CACHE_COMPRESSION);
    $ADEI_TRANSACTION_SIZE = env("ADEI_TRANSACTION_SIZE", $ADEI_TRANSACTION_SIZE);
    $ADEI_CONTINUOUS_TRANSACTION =  env("ADEI_CONTINUOUS_TRANSACTION", $ADEI_CONTINUOUS_TRANSACTION);

    $ADEI_CACHE_SCHEDULER = env("ADEI_SCHEDULER", $ADEI_CACHE_SCHEDULER);
    $ADEI_CONTINUOUS_CACHING = filter_var(env("ADEI_CONTINUOUS_CACHING", $ADEI_CONTINUOUS_CACHING), FILTER_VALIDATE_BOOLEAN);
?>
